package com.contextspace.internalexception;

import java.io.Serializable;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Inheritance;
import javax.persistence.InheritanceType;
import javax.persistence.TableGenerator;
import javax.persistence.Version;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

@Entity
@Inheritance(strategy=InheritanceType.TABLE_PER_CLASS)
@TableGenerator(name="IdTableGen", initialValue=1, allocationSize=50)
public class BaseObject implements Serializable{
    private static final long serialVersionUID = 1L;

    static Logger log = LoggerFactory.getLogger(BaseObject.class.getName());
    
    private long version;
    
    private long id;

    /**
     * @return the object id
     */
    @Id
    @GeneratedValue(strategy=GenerationType.TABLE, generator="IdTableGen")
    public long getId() {
        return id;
    }

    /**
     * @param id the id to be set
     */
    public void setId(long id) {
        this.id = id;
    }

    @Version
    public long getVersion() {
        return version;
    }  
}
