package com.contextspace.internalexception;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.NoResultException;
import javax.persistence.Persistence;
import javax.persistence.TypedQuery;

import org.junit.Test;

import com.contextspace.internalexception.Relationship.RelationshipType;

public class TestInternalException {

    @Test
    public void test() {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("objectdb:$objectdb/db/test.tmp;drop");
        EntityManager em = emf.createEntityManager();
     
        
        em.getTransaction().begin();
        
        CDI cdi = new CDI("cdiid");
        cdi.setFirstname("firstname");
        cdi.setLastname("lastname");
        cdi.setAccountNumber("12345");
        cdi.setStatus("active");
        em.persist(cdi);
        
        Role role = new Role("test_roleId");
        em.persist(role);
        
        Relationship rel = new Relationship(cdi,role,RelationshipType.OWNER);
        em.persist(rel);
        
        em.getTransaction().commit();
     
        TypedQuery<CDI> query = em.createQuery(
                "SELECT e FROM CDI e, Relationship r, Role role WHERE role.roleId = :role_id AND r.otherParty = role AND r.relationshipType=RelationshipType.OWNER AND r.party.id=e.id", CDI.class);
        query.setParameter("role_id", "test_roleId");
        
        CDI result =  null;
        try {
            result = query.getSingleResult();
            System.out.println("Found: " + result);
        } catch (NoResultException e){
            System.out.println("No Owning CDI was found for Role");
            System.out.println("FAIL");
        }
        
        em.close();
        emf.close();
    }

}
